#include <stdio.h>
#include <conio.h>
#include <stdlib.h>
#include <dir.h>

struct {
	  unsigned short digit_counter : 3;
	  unsigned short more : 1;
	  unsigned short current_color : 8;
	  unsigned short bold : 1;
	  unsigned short blink : 1;
       } variables;

struct {
	  unsigned short x : 7;
	  unsigned short y : 5;
       } cursor;

short number_counter = 0; /* counts number of variables */
char command_letter;   /* ANSI command letter */
short variable[5];        /* variables after conferted to an integer */

void ansi_function(void);
void main(int argc, char *argv[])
{
   FILE *ansi;  /* file pointer to ANSI file to be displayed */
   char ch;     /* temporary charachter after read from file */
   char number[5][4];  /* Variables in ASCII form */

   variables.bold = 0;
   variables.current_color = 7;
   cursor.x = 1;
   cursor.y = 1;

   textattr(7);

   if (argc == 1 || argc > 2)
   {
      clrscr();
      printf("\nProper syntax:");
      printf("\n    ANSI.EXE <file>.ans");
      exit(0);
   }
   if ((ansi = fopen(argv[1], "rb")) == NULL)
   {
      clrscr();
      printf("\nInvalid Filename!");
      printf("\nProper Syntax:");
      printf("\n    ANSI.EXE <file>.ans");
      exit(0);
   }
   else
   {
      while ((ch = fgetc(ansi)) != EOF)    /* reads charachter from file */
      {
	 if (ch != 27)
	 {
	    putch(ch);     /* checks for escape code */
	    continue;
	 }
         else
	 {
	    number_counter = 0;
	    variable[0] = NULL;
	    variable[1] = NULL;
	    variable[2] = NULL;
	    variable[3] = NULL;
	    variable[4] = NULL;

	    if (fgetc(ansi) != '[')     /* Makes sure it is an ANSI code */
	    {
	       putch(ch);
	       continue;       /* recycles loop if not code */
	    }
	    variables.more = 1;
	    number_counter = 0;
	    while (variables.more == 1)
	    {
	       variables.digit_counter = 0;
	       while ((ch = fgetc(ansi)) >= '0' && ch <= '9')
	       {
		  number[number_counter][variables.digit_counter] = ch;
		  variables.digit_counter++; /* reads in variables and increments */
	       }                   /* digit counter */
	       if (variables.digit_counter == 0) number[number_counter][0] = 0;
	       if (variables.digit_counter == 1) number[number_counter][1] = 0;
	       if (variables.digit_counter == 2) number[number_counter][2] = 0;
	       if (variables.digit_counter >= 3) number[number_counter][3] = 0;
	       variable[number_counter] = atoi(number[number_counter]);
	       if (variables.digit_counter > 0) number_counter++;
	       if (ch != ';')             /* converts string to short */
	       {
		  variables.more = 0;
		  command_letter = ch;     /* assigns cammand charachter */
		  ansi_function();
	       }                           /* to variable */
	    }
	 }
      }
   }
}

void ansi_function(void)
{
   short counter = 0;

   if (command_letter == 'H')
   {
      if (number_counter == 0)
      {
	 gotoxy(1, 1);
	 return;
      }
      else
      {
	 gotoxy(variable[1], variable[0]);
	 return;
      }
   }

   if (command_letter == 'f')
   {
      gotoxy(variable[1], variable[0]);
      return;
   }

   if (command_letter == 'A')
   {
      if (number_counter == 0)
      {
	 gotoxy(wherex(), wherey() - 1);
      }
      else
      {
	 gotoxy(wherex(), wherey() - variable[0]);
      }
      return;
   }

   if (command_letter == 'B')
   {
      if (number_counter == 0)
      {
	 gotoxy(wherex(), wherey() + 1);
      }
      else
      {
	 gotoxy(wherex(), wherey() + variable[0]);
      }
      return;
   }

   if (command_letter == 'C')
   {
      if (number_counter == 0)
      {
	 gotoxy(wherex() + 1, wherey());
      }
      else
      {
	 gotoxy(wherex() + variable[0], wherey());
      }
      return;
   }

   if (command_letter == 'D')
   {
      if (number_counter == 0)
      {
	 gotoxy(wherex() - 1, wherey());
      }
      else
      {
	 gotoxy(wherex() - variable[0], wherey());
      }
      return;
   }

   if (command_letter == 's')
   {
      cursor.x = wherex();
      cursor.y = wherey();
      return;
   }

   if (command_letter == 'u')
   {
      gotoxy(cursor.x, cursor.y);
      return;
   }

   if (command_letter == 'J')
   {
      if (variable[0] == 2)
      {
	 clrscr();
	 gotoxy(1, 1);
	 return;
      }
   }

   if (command_letter == 'K')
   {
      clreol();
      return;
   }

   if (command_letter == 'm')
   {
      while (counter != number_counter)
      {
	 if (variable[counter] == 1 && variables.bold == 0)
	 {
	    variables.current_color = variables.current_color + 8;
	    textattr(variables.current_color);
	    variables.bold = 1;
	    counter++;
	    continue;
	 }
	 if (variable[counter] == 1 && variables.bold == 1)
	 {
	    variables.current_color = variables.current_color - 8;
	    textattr(variables.current_color);
	    variables.bold = 0;
	    counter++;
	    continue;
	 }

	 if (variable[counter] == 0)
	 {
	    textattr(7);
	    variables.current_color = 7;
	    variables.bold = 0;
	    variables.blink = 0;
	    counter++;
	    continue;
	 }
	 if (variable[counter] == 5)
	 {
	    if (variables.blink == 1)
	    {
	       variables.blink = 0;
	       variables.current_color -= 128;
	    }
	    if (variables.blink == 0)
	    {
	       variables.blink = 1;
	       variables.current_color += 128;
	    }
	    textattr(variables.current_color);
	    counter++;
	    continue;
	 }

	 if ((variable[counter] > 29) && (variable[counter] < 38))
	 {
	    if (variable[counter] == 30)
	       variables.current_color = 0;
	    else if (variable[counter] == 31)
	       variables.current_color = 4;
	    else if (variable[counter] == 32)
	       variables.current_color = 2;
	    else if (variable[counter] == 33)
	       variables.current_color = 6;
	    else if (variable[counter] == 34)
	       variables.current_color = 1;
	    else if (variable[counter] == 35)
	       variables.current_color = 5;
	    else if (variable[counter] == 36)
	       variables.current_color = 3;
	    else if (variable[counter] == 37)
	       variables.current_color = 7;

	    if (variables.bold == 1)
	       variables.current_color += 8;
	    if (variables.blink == 1)
	       variables.current_color += 128;

	    textattr(variables.current_color);
	    counter++;
	    continue;
	 }

	 if (variable[counter] >= 40 && variable[counter] <= 47)
	 {
	    if (variable[counter] == 40)
	       textattr(variables.current_color);
	    if (variable[counter] == 41)
	       textattr(variables.current_color + 64);
	    if (variable[counter] == 42)
	       textattr(variables.current_color + 32);
	    if (variable[counter] == 43)
	       textattr(variables.current_color + 96);
	    if (variable[counter] == 44)
	       textattr(variables.current_color + 16);
	    if (variable[counter] == 45)
	       textattr(variables.current_color + 80);
	    if (variable[counter] == 46)
	       textattr(variables.current_color + 48);
	    if (variable[counter] == 47)
	       textattr(variables.current_color + 112);

	    counter++;
	    continue;
	 }
      }
   }
}
